package org.antlr.analysis;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.analysis.NFAState;

public class NFAContext {
  public static int MAX_SAME_RULE_INVOCATIONS_PER_NFA_CONFIG_STACK = 4;
  
  public org.antlr.analysis.NFAContext parent;
  
  public NFAState invokingState;
  
  protected int cachedHashCode;
  
  public NFAContext(org.antlr.analysis.NFAContext parent, NFAState invokingState) {
    this.parent = parent;
    this.invokingState = invokingState;
    if (invokingState != null)
      this.cachedHashCode = invokingState.stateNumber; 
    if (parent != null)
      this.cachedHashCode += parent.cachedHashCode; 
  }
  
  public boolean equals(Object o) {
    org.antlr.analysis.NFAContext other = (org.antlr.analysis.NFAContext)o;
    if (this.cachedHashCode != other.cachedHashCode)
      return false; 
    if (this == other)
      return true; 
    org.antlr.analysis.NFAContext sp = this;
    while (sp.parent != null && other.parent != null) {
      if (sp.invokingState != other.invokingState)
        return false; 
      sp = sp.parent;
      other = other.parent;
    } 
    if (sp.parent != null || other.parent != null)
      return false; 
    return true;
  }
  
  public boolean conflictsWith(org.antlr.analysis.NFAContext other) {
    return suffix(other);
  }
  
  protected boolean suffix(org.antlr.analysis.NFAContext other) {
    org.antlr.analysis.NFAContext sp = this;
    while (sp.parent != null && other.parent != null) {
      if (sp.invokingState != other.invokingState)
        return false; 
      sp = sp.parent;
      other = other.parent;
    } 
    return true;
  }
  
  public int recursionDepthEmanatingFromState(int state) {
    org.antlr.analysis.NFAContext sp = this;
    int n = 0;
    while (sp.parent != null) {
      if (sp.invokingState.stateNumber == state)
        n++; 
      sp = sp.parent;
    } 
    return n;
  }
  
  public int hashCode() {
    return this.cachedHashCode;
  }
  
  public boolean isEmpty() {
    return (this.parent == null);
  }
  
  public String toString() {
    StringBuilder buf = new StringBuilder();
    org.antlr.analysis.NFAContext sp = this;
    buf.append("[");
    while (sp.parent != null) {
      buf.append(sp.invokingState.stateNumber);
      buf.append(" ");
      sp = sp.parent;
    } 
    buf.append("$]");
    return buf.toString();
  }
}
